1#!/bin/sh
2#
3# Copyright (c) 2006 Eric Wong
4#
5
6PERL='@@PERL@@'
7OPTIONS_KEEPDASHDASH=
8OPTIONS_STUCKLONG=
9OPTIONS_SPEC="\
10git instaweb [options] (--start | --stop | --restart)
11--
12l,local only bind on 127.0.0.1
13p,port= the port to bind to
14d,httpd= the command to launch
15b,browser= the browser to launch
16m,module-path= the module path (only needed for apache2)
17 Action
18stop stop the web server
19start start the web server
20restart restart the web server
21"
22
23. git-sh-setup
24
25fqgitdir="$GIT_DIR"
26local="$(git config --bool --get instaweb.local)"
27httpd="$(git config --get instaweb.httpd)"
28root="$(git config --get instaweb.gitwebdir)"
29port=$(git config --get instaweb.port)
30module_path="$(git config --get instaweb.modulepath)"
31action="browse"
32
33conf="$GIT_DIR/gitweb/httpd.conf"
34
35# Defaults:
36
37# if installed, it doesn't need further configuration (module_path)
38test -z "$httpd" && httpd='lighttpd -f'
39
40# Default is @@GITWEBDIR@@
41test -z "$root" && root='@@GITWEBDIR@@'
42
43# any untaken local port will do...
44test -z "$port" && port=1234
45
46resolve_full_httpd () {
47 case "$httpd" in
48 *apache2*|*lighttpd*|*httpd*)
49 # yes, *httpd* covers *lighttpd* above, but it is there for clarity
50 # ensure that the apache2/lighttpd command ends with "-f"
51 if ! echo "$httpd" | sane_grep -- '-f *$' >/dev/null 2>&1
52 then
53 httpd="$httpd -f"
54 fi
55 ;;
56 *plackup*)
57 # server is started by running via generated gitweb.psgi in $fqgitdir/gitweb
58 full_httpd="$fqgitdir/gitweb/gitweb.psgi"
59 httpd_only="${httpd%% *}" # cut on first space
60 return
61 ;;
62 *webrick*)
63 # server is started by running via generated webrick.rb in
64 # $fqgitdir/gitweb
65 full_httpd="$fqgitdir/gitweb/webrick.rb"
66 httpd_only="${httpd%% *}" # cut on first space
67 return
68 ;;
69 esac
70
71 httpd_only="$(echo $httpd | cut -f1 -d' ')"
72 if case "$httpd_only" in /*) : ;; *) which $httpd_only >/dev/null 2>&1;; esac
73 then
74 full_httpd=$httpd
75 else
76 # many httpds are installed in /usr/sbin or /usr/local/sbin
77 # these days and those are not in most users $PATHs
78 # in addition, we may have generated a server script
79 # in $fqgitdir/gitweb.
80 for i in /usr/local/sbin /usr/sbin "$root" "$fqgitdir/gitweb"
81 do
82 if test -x "$i/$httpd_only"
83 then
84 full_httpd=$i/$httpd
85 return
86 fi
87 done
88
89 echo >&2 "$httpd_only not found. Install $httpd_only or use" \
90 "--httpd to specify another httpd daemon."
91 exit 1
92 fi
93}
94
95start_httpd () {
96 if test -f "$fqgitdir/pid"; then
97 say "Instance already running. Restarting..."
98 stop_httpd
99 fi
100
101 # here $httpd should have a meaningful value
102 resolve_full_httpd
103 mkdir -p "$fqgitdir/gitweb/$httpd_only"
104 conf="$fqgitdir/gitweb/$httpd_only.conf"
105
106 # generate correct config file if it doesn't exist
107 test -f "$conf" || configure_httpd
108 test -f "$fqgitdir/gitweb/gitweb_config.perl" || gitweb_conf
109
110 # don't quote $full_httpd, there can be arguments to it (-f)
111 case "$httpd" in
112 *mongoose*|*plackup*)
113 #These servers don't have a daemon mode so we'll have to fork it
114 $full_httpd "$conf" &
115 #Save the pid before doing anything else (we'll print it later)
116 pid=$!
117
118 if test $? != 0; then
119 echo "Could not execute http daemon $httpd."
120 exit 1
121 fi
122
123 cat > "$fqgitdir/pid" <<EOF
124$pid
125EOF
126 ;;
127 *)
128 $full_httpd "$conf"
129 if test $? != 0; then
130 echo "Could not execute http daemon $httpd."
131 exit 1
132 fi
133 ;;
134 esac
135}
136
137stop_httpd () {
138 test -f "$fqgitdir/pid" && kill $(cat "$fqgitdir/pid")
139 rm -f "$fqgitdir/pid"
140}
141
142httpd_is_ready () {
143 "$PERL" -MIO::Socket::INET -e "
144local \$| = 1; # turn on autoflush
145exit if (IO::Socket::INET->new('127.0.0.1:$port'));
146print 'Waiting for \'$httpd\' to start ..';
147do {
148 print '.';
149 sleep(1);
150} until (IO::Socket::INET->new('127.0.0.1:$port'));
151print qq! (done)\n!;
152"
153}
154
155while test $# != 0
156do
157 case "$1" in
158 --stop|stop)
159 action="stop"
160 ;;
161 --start|start)
162 action="start"
163 ;;
164 --restart|restart)
165 action="restart"
166 ;;
167 -l|--local)
168 local=true
169 ;;
170 -d|--httpd)
171 shift
172 httpd="$1"
173 ;;
174 -b|--browser)
175 shift
176 browser="$1"
177 ;;
178 -p|--port)
179 shift
180 port="$1"
181 ;;
182 -m|--module-path)
183 shift
184 module_path="$1"
185 ;;
186 --)
187 ;;
188 *)
189 usage
190 ;;
191 esac
192 shift
193done
194
195mkdir -p "$GIT_DIR/gitweb/tmp"
196GIT_EXEC_PATH="$(git --exec-path)"
197GIT_DIR="$fqgitdir"
198GITWEB_CONFIG="$fqgitdir/gitweb/gitweb_config.perl"
199export GIT_EXEC_PATH GIT_DIR GITWEB_CONFIG
200
201webrick_conf () {
202 # webrick seems to have no way of passing arbitrary environment
203 # variables to the underlying CGI executable, so we wrap the
204 # actual gitweb.cgi using a shell script to force it
205 wrapper="$fqgitdir/gitweb/$httpd/wrapper.sh"
206 cat > "$wrapper" <<EOF
207#!/bin/sh
208# we use this shell script wrapper around the real gitweb.cgi since
209# there appears to be no other way to pass arbitrary environment variables
210# into the CGI process
211GIT_EXEC_PATH=$GIT_EXEC_PATH GIT_DIR=$GIT_DIR GITWEB_CONFIG=$GITWEB_CONFIG
212export GIT_EXEC_PATH GIT_DIR GITWEB_CONFIG
213exec $root/gitweb.cgi
214EOF
215 chmod +x "$wrapper"
216
217 # This assumes _ruby_ is in the user's $PATH. that's _one_
218 # portable way to run ruby, which could be installed anywhere, really.
219 # generate a standalone server script in $fqgitdir/gitweb.
220 cat >"$fqgitdir/gitweb/$httpd.rb" <<EOF
221#!/usr/bin/env ruby
222require 'webrick'
223require 'logger'
224options = {
225 :Port => $port,
226 :DocumentRoot => "$root",
227 :Logger => Logger.new('$fqgitdir/gitweb/error.log'),
228 :AccessLog => [
229 [ Logger.new('$fqgitdir/gitweb/access.log'),
230 WEBrick::AccessLog::COMBINED_LOG_FORMAT ]
231 ],
232 :DirectoryIndex => ["gitweb.cgi"],
233 :CGIInterpreter => "$wrapper",
234 :StartCallback => lambda do
235 File.open("$fqgitdir/pid", "w") { |f| f.puts Process.pid }
236 end,
237 :ServerType => WEBrick::Daemon,
238}
239options[:BindAddress] = '127.0.0.1' if "$local" == "true"
240server = WEBrick::HTTPServer.new(options)
241['INT', 'TERM'].each do |signal|
242 trap(signal) {server.shutdown}
243end
244server.start
245EOF
246 chmod +x "$fqgitdir/gitweb/$httpd.rb"
247 # configuration is embedded in server script file, webrick.rb
248 rm -f "$conf"
249}
250
251lighttpd_conf () {
252 cat > "$conf" <<EOF
253server.document-root = "$root"
254server.port = $port
255server.modules = ( "mod_setenv", "mod_cgi" )
256server.indexfiles = ( "gitweb.cgi" )
257server.pid-file = "$fqgitdir/pid"
258server.errorlog = "$fqgitdir/gitweb/$httpd_only/error.log"
259
260# to enable, add "mod_access", "mod_accesslog" to server.modules
261# variable above and uncomment this
262#accesslog.filename = "$fqgitdir/gitweb/$httpd_only/access.log"
263
264setenv.add-environment = ( "PATH" => env.PATH, "GITWEB_CONFIG" => env.GITWEB_CONFIG )
265
266cgi.assign = ( ".cgi" => "" )
267
268# mimetype mapping
269mimetype.assign = (
270 ".pdf" => "application/pdf",
271 ".sig" => "application/pgp-signature",
272 ".spl" => "application/futuresplash",
273 ".class" => "application/octet-stream",
274 ".ps" => "application/postscript",
275 ".torrent" => "application/x-bittorrent",
276 ".dvi" => "application/x-dvi",
277 ".gz" => "application/x-gzip",
278 ".pac" => "application/x-ns-proxy-autoconfig",
279 ".swf" => "application/x-shockwave-flash",
280 ".tar.gz" => "application/x-tgz",
281 ".tgz" => "application/x-tgz",
282 ".tar" => "application/x-tar",
283 ".zip" => "application/zip",
284 ".mp3" => "audio/mpeg",
285 ".m3u" => "audio/x-mpegurl",
286 ".wma" => "audio/x-ms-wma",
287 ".wax" => "audio/x-ms-wax",
288 ".ogg" => "application/ogg",
289 ".wav" => "audio/x-wav",
290 ".gif" => "image/gif",
291 ".jpg" => "image/jpeg",
292 ".jpeg" => "image/jpeg",
293 ".png" => "image/png",
294 ".xbm" => "image/x-xbitmap",
295 ".xpm" => "image/x-xpixmap",
296 ".xwd" => "image/x-xwindowdump",
297 ".css" => "text/css",
298 ".html" => "text/html",
299 ".htm" => "text/html",
300 ".js" => "text/javascript",
301 ".asc" => "text/plain",
302 ".c" => "text/plain",
303 ".cpp" => "text/plain",
304 ".log" => "text/plain",
305 ".conf" => "text/plain",
306 ".text" => "text/plain",
307 ".txt" => "text/plain",
308 ".dtd" => "text/xml",
309 ".xml" => "text/xml",
310 ".mpeg" => "video/mpeg",
311 ".mpg" => "video/mpeg",
312 ".mov" => "video/quicktime",
313 ".qt" => "video/quicktime",
314 ".avi" => "video/x-msvideo",
315 ".asf" => "video/x-ms-asf",
316 ".asx" => "video/x-ms-asf",
317 ".wmv" => "video/x-ms-wmv",
318 ".bz2" => "application/x-bzip",
319 ".tbz" => "application/x-bzip-compressed-tar",
320 ".tar.bz2" => "application/x-bzip-compressed-tar",
321 "" => "text/plain"
322 )
323EOF
324 test x"$local" = xtrue && echo 'server.bind = "127.0.0.1"' >> "$conf"
325}
326
327apache2_conf () {
328 if test -z "$module_path"
329 then
330 test -d "/usr/lib/httpd/modules" &&
331 module_path="/usr/lib/httpd/modules"
332 test -d "/usr/lib/apache2/modules" &&
333 module_path="/usr/lib/apache2/modules"
334 fi
335 bind=
336 test x"$local" = xtrue && bind='127.0.0.1:'
337 echo 'text/css css' > "$fqgitdir/mime.types"
338 cat > "$conf" <<EOF
339ServerName "git-instaweb"
340ServerRoot "$root"
341DocumentRoot "$root"
342ErrorLog "$fqgitdir/gitweb/$httpd_only/error.log"
343CustomLog "$fqgitdir/gitweb/$httpd_only/access.log" combined
344PidFile "$fqgitdir/pid"
345Listen $bind$port
346EOF
347
348 for mod in mime dir env log_config
349 do
350 if test -e $module_path/mod_${mod}.so
351 then
352 echo "LoadModule ${mod}_module " \
353 "$module_path/mod_${mod}.so" >> "$conf"
354 fi
355 done
356 cat >> "$conf" <<EOF
357TypesConfig "$fqgitdir/mime.types"
358DirectoryIndex gitweb.cgi
359EOF
360
361 # check to see if Dennis Stosberg's mod_perl compatibility patch
362 # (<20060621130708.Gcbc6e5c@leonov.stosberg.net>) has been applied
363 if test -f "$module_path/mod_perl.so" &&
364 sane_grep 'MOD_PERL' "$root/gitweb.cgi" >/dev/null
365 then
366 # favor mod_perl if available
367 cat >> "$conf" <<EOF
368LoadModule perl_module $module_path/mod_perl.so
369PerlPassEnv GIT_DIR
370PerlPassEnv GIT_EXEC_PATH
371PerlPassEnv GITWEB_CONFIG
372<Location /gitweb.cgi>
373 SetHandler perl-script
374 PerlResponseHandler ModPerl::Registry
375 PerlOptions +ParseHeaders
376 Options +ExecCGI
377</Location>
378EOF
379 else
380 # plain-old CGI
381 resolve_full_httpd
382 list_mods=$(echo "$full_httpd" | sed 's/-f$/-l/')
383 $list_mods | sane_grep 'mod_cgi\.c' >/dev/null 2>&1 || \
384 if test -f "$module_path/mod_cgi.so"
385 then
386 echo "LoadModule cgi_module $module_path/mod_cgi.so" >> "$conf"
387 else
388 $list_mods | grep 'mod_cgid\.c' >/dev/null 2>&1 || \
389 if test -f "$module_path/mod_cgid.so"
390 then
391 echo "LoadModule cgid_module $module_path/mod_cgid.so" \
392 >> "$conf"
393 else
394 echo "You have no CGI support!"
395 exit 2
396 fi
397 echo "ScriptSock logs/gitweb.sock" >> "$conf"
398 fi
399 cat >> "$conf" <<EOF
400PassEnv GIT_DIR
401PassEnv GIT_EXEC_PATH
402PassEnv GITWEB_CONFIG
403AddHandler cgi-script .cgi
404<Location /gitweb.cgi>
405 Options +ExecCGI
406</Location>
407EOF
408 fi
409}
410
411mongoose_conf() {
412 cat > "$conf" <<EOF
413# Mongoose web server configuration file.
414# Lines starting with '#' and empty lines are ignored.
415# For detailed description of every option, visit
416# http://code.google.com/p/mongoose/wiki/MongooseManual
417
418root $root
419ports $port
420index_files gitweb.cgi
421#ssl_cert $fqgitdir/gitweb/ssl_cert.pem
422error_log $fqgitdir/gitweb/$httpd_only/error.log
423access_log $fqgitdir/gitweb/$httpd_only/access.log
424
425#cgi setup
426cgi_env PATH=$PATH,GIT_DIR=$GIT_DIR,GIT_EXEC_PATH=$GIT_EXEC_PATH,GITWEB_CONFIG=$GITWEB_CONFIG
427cgi_interp $PERL
428cgi_ext cgi,pl
429
430# mimetype mapping
431mime_types .gz=application/x-gzip,.tar.gz=application/x-tgz,.tgz=application/x-tgz,.tar=application/x-tar,.zip=application/zip,.gif=image/gif,.jpg=image/jpeg,.jpeg=image/jpeg,.png=image/png,.css=text/css,.html=text/html,.htm=text/html,.js=text/javascript,.c=text/plain,.cpp=text/plain,.log=text/plain,.conf=text/plain,.text=text/plain,.txt=text/plain,.dtd=text/xml,.bz2=application/x-bzip,.tbz=application/x-bzip-compressed-tar,.tar.bz2=application/x-bzip-compressed-tar
432EOF
433}
434
435plackup_conf () {
436 # generate a standalone 'plackup' server script in $fqgitdir/gitweb
437 # with embedded configuration; it does not use "$conf" file
438 cat > "$fqgitdir/gitweb/gitweb.psgi" <<EOF
439#!$PERL
440
441# gitweb - simple web interface to track changes in git repositories
442# PSGI wrapper and server starter (see http://plackperl.org)
443
444use strict;
445
446use IO::Handle;
447use Plack::MIME;
448use Plack::Builder;
449use Plack::App::WrapCGI;
450use CGI::Emulate::PSGI 0.07; # minimum version required to work with gitweb
451
452# mimetype mapping (from lighttpd_conf)
453Plack::MIME->add_type(
454 ".pdf" => "application/pdf",
455 ".sig" => "application/pgp-signature",
456 ".spl" => "application/futuresplash",
457 ".class" => "application/octet-stream",
458 ".ps" => "application/postscript",
459 ".torrent" => "application/x-bittorrent",
460 ".dvi" => "application/x-dvi",
461 ".gz" => "application/x-gzip",
462 ".pac" => "application/x-ns-proxy-autoconfig",
463 ".swf" => "application/x-shockwave-flash",
464 ".tar.gz" => "application/x-tgz",
465 ".tgz" => "application/x-tgz",
466 ".tar" => "application/x-tar",
467 ".zip" => "application/zip",
468 ".mp3" => "audio/mpeg",
469 ".m3u" => "audio/x-mpegurl",
470 ".wma" => "audio/x-ms-wma",
471 ".wax" => "audio/x-ms-wax",
472 ".ogg" => "application/ogg",
473 ".wav" => "audio/x-wav",
474 ".gif" => "image/gif",
475 ".jpg" => "image/jpeg",
476 ".jpeg" => "image/jpeg",
477 ".png" => "image/png",
478 ".xbm" => "image/x-xbitmap",
479 ".xpm" => "image/x-xpixmap",
480 ".xwd" => "image/x-xwindowdump",
481 ".css" => "text/css",
482 ".html" => "text/html",
483 ".htm" => "text/html",
484 ".js" => "text/javascript",
485 ".asc" => "text/plain",
486 ".c" => "text/plain",
487 ".cpp" => "text/plain",
488 ".log" => "text/plain",
489 ".conf" => "text/plain",
490 ".text" => "text/plain",
491 ".txt" => "text/plain",
492 ".dtd" => "text/xml",
493 ".xml" => "text/xml",
494 ".mpeg" => "video/mpeg",
495 ".mpg" => "video/mpeg",
496 ".mov" => "video/quicktime",
497 ".qt" => "video/quicktime",
498 ".avi" => "video/x-msvideo",
499 ".asf" => "video/x-ms-asf",
500 ".asx" => "video/x-ms-asf",
501 ".wmv" => "video/x-ms-wmv",
502 ".bz2" => "application/x-bzip",
503 ".tbz" => "application/x-bzip-compressed-tar",
504 ".tar.bz2" => "application/x-bzip-compressed-tar",
505 "" => "text/plain"
506);
507
508my \$app = builder {
509 # to be able to override \$SIG{__WARN__} to log build time warnings
510 use CGI::Carp; # it sets \$SIG{__WARN__} itself
511
512 my \$logdir = "$fqgitdir/gitweb/$httpd_only";
513 open my \$access_log_fh, '>>', "\$logdir/access.log"
514 or die "Couldn't open access log '\$logdir/access.log': \$!";
515 open my \$error_log_fh, '>>', "\$logdir/error.log"
516 or die "Couldn't open error log '\$logdir/error.log': \$!";
517
518 \$access_log_fh->autoflush(1);
519 \$error_log_fh->autoflush(1);
520
521 # redirect build time warnings to error.log
522 \$SIG{'__WARN__'} = sub {
523 my \$msg = shift;
524 # timestamp warning like in CGI::Carp::warn
525 my \$stamp = CGI::Carp::stamp();
526 \$msg =~ s/^/\$stamp/gm;
527 print \$error_log_fh \$msg;
528 };
529
530 # write errors to error.log, access to access.log
531 enable 'AccessLog',
532 format => "combined",
533 logger => sub { print \$access_log_fh @_; };
534 enable sub {
535 my \$app = shift;
536 sub {
537 my \$env = shift;
538 \$env->{'psgi.errors'} = \$error_log_fh;
539 \$app->(\$env);
540 }
541 };
542 # gitweb currently doesn't work with $SIG{CHLD} set to 'IGNORE',
543 # because it uses 'close $fd or die...' on piped filehandle $fh
544 # (which causes the parent process to wait for child to finish).
545 enable_if { \$SIG{'CHLD'} eq 'IGNORE' } sub {
546 my \$app = shift;
547 sub {
548 my \$env = shift;
549 local \$SIG{'CHLD'} = 'DEFAULT';
550 local \$SIG{'CLD'} = 'DEFAULT';
551 \$app->(\$env);
552 }
553 };
554 # serve static files, i.e. stylesheet, images, script
555 enable 'Static',
556 path => sub { m!\.(js|css|png)\$! && s!^/gitweb/!! },
557 root => "$root/",
558 encoding => 'utf-8'; # encoding for 'text/plain' files
559 # convert CGI application to PSGI app
560 Plack::App::WrapCGI->new(script => "$root/gitweb.cgi")->to_app;
561};
562
563# make it runnable as standalone app,
564# like it would be run via 'plackup' utility
565if (caller) {
566 return \$app;
567} else {
568 require Plack::Runner;
569
570 my \$runner = Plack::Runner->new();
571 \$runner->parse_options(qw(--env deployment --port $port),
572 "$local" ? qw(--host 127.0.0.1) : ());
573 \$runner->run(\$app);
574}
575__END__
576EOF
577
578 chmod a+x "$fqgitdir/gitweb/gitweb.psgi"
579 # configuration is embedded in server script file, gitweb.psgi
580 rm -f "$conf"
581}
582
583gitweb_conf() {
584 cat > "$fqgitdir/gitweb/gitweb_config.perl" <<EOF
585#!@@PERL@@
586our \$projectroot = "$(dirname "$fqgitdir")";
587our \$git_temp = "$fqgitdir/gitweb/tmp";
588our \$projects_list = \$projectroot;
589
590\$feature{'remote_heads'}{'default'} = [1];
591EOF
592}
593
594configure_httpd() {
595 case "$httpd" in
596 *lighttpd*)
597 lighttpd_conf
598 ;;
599 *apache2*|*httpd*)
600 apache2_conf
601 ;;
602 webrick)
603 webrick_conf
604 ;;
605 *mongoose*)
606 mongoose_conf
607 ;;
608 *plackup*)
609 plackup_conf
610 ;;
611 *)
612 echo "Unknown httpd specified: $httpd"
613 exit 1
614 ;;
615 esac
616}
617
618case "$action" in
619stop)
620 stop_httpd
621 exit 0
622 ;;
623start)
624 start_httpd
625 exit 0
626 ;;
627restart)
628 stop_httpd
629 start_httpd
630 exit 0
631 ;;
632esac
633
634gitweb_conf
635
636resolve_full_httpd
637mkdir -p "$fqgitdir/gitweb/$httpd_only"
638conf="$fqgitdir/gitweb/$httpd_only.conf"
639
640configure_httpd
641
642start_httpd
643url=http://127.0.0.1:$port
644
645if test -n "$browser"; then
646 httpd_is_ready && git web--browse -b "$browser" $url || echo $url
647else
648 httpd_is_ready && git web--browse -c "instaweb.browser" $url || echo $url
649fi